/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.eingang.semantik.enginebased.formsolutions;

import static de.ozgcloud.eingang.semantik.enginebased.formsolutions.FormSolutionsEngineBasedAdapter.*;
import static de.ozgcloud.eingang.semantik.enginebased.formsolutions.FormSolutionsPanelMapper.*;

import java.util.List;
import java.util.Map;

import de.ozgcloud.eingang.common.formdata.FormData;

public class FormSolutionsPanelTestFactory {
	public static final String PANEL_0 = "Panel_0_1";
	public static final String TEXT_FIELD = "Textfeld (einzeilig)";
	public static final String DATE_FIELD = "Datums- / Uhrzeitfeld";
	public static final String STRING_VALUE_CONTENT = "kfjhkfjhk";
	public static final String DATE_VALUE_CONTENT = "22.05.1996";
	public static final String GROUP_IDENTIFIER = "Objektgruppe[0]";
	public static final String FORM = "AS_123";
	public static final List<Map<String, Object>> COMPONENT_LIST = List.of(
			Map.of(
					IDENTIFIER, TEXT_FIELD,
					STRING_VALUE, STRING_VALUE_CONTENT),
			Map.of(
					IDENTIFIER, DATE_FIELD,
					STRING_VALUE, DATE_VALUE_CONTENT));

	public static final List<Map<String, Object>> EMPTY_COMPONENT_LIST = List.of(
			Map.of(IDENTIFIER, TEXT_FIELD, "needed", false));

	public static final List<Map<String, Object>> NESTED_COMPONENT_LIST = List.of(
			Map.of(
					IDENTIFIER, GROUP_IDENTIFIER,
					COMPONENTS, List.of(Map.of(
							IDENTIFIER, DATE_FIELD,
							STRING_VALUE, DATE_VALUE_CONTENT))));

	public static final List<Map<String, Object>> PANEL_LIST = List.of(Map.of(
			IDENTIFIER, PANEL_0,
			COMPONENTS, COMPONENT_LIST));

	public static final List<Map<String, Object>> PANEL_LIST_EMPTY = List.of(Map.of(
			IDENTIFIER, PANEL_0,
			COMPONENTS, EMPTY_COMPONENT_LIST));

	public static final List<Map<String, Object>> NESTED_PANEL_LIST = List.of(Map.of(
			IDENTIFIER, PANEL_0,
			COMPONENTS, NESTED_COMPONENT_LIST));

	public static final Map<String, Object> PANEL_FORM = Map.of(
			ASSISTANT, Map.of(
					IDENTIFIER, FORM,
					PANELS, PANEL_LIST));

	public static final Map<String, Object> NESTED_PANEL_FORM = Map.of(
			ASSISTANT, Map.of(
					IDENTIFIER, FORM,
					PANELS, NESTED_PANEL_LIST));

	public static final Map<String, Object> PANEL_FORM_EMPTY = Map.of(
			ASSISTANT, Map.of(
					IDENTIFIER, FORM,
					PANELS, PANEL_LIST_EMPTY));

	public static FormData create() {
		return FormSolutionsPanelTestFactory.createBuilder().build();
	}

	public static FormData.FormDataBuilder createBuilder() {
		return FormData.builder().formData(PANEL_FORM);
	}
}
